#ifndef _BASE_3D_H
#define _BASE_3D_H

#include <allegro.h>
#include <list>

#include <fstream>
#include <iomanip>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <climits>

const double CLIP_PLANE_EPSILON = 0.0001;

const double MOVEMENT_SPEED	=	64.0;
const double MAX_MOVEMENT_SPEED	=	256.0;

const int CO_PLANAR =  0;  // BSP classifications
const int BACK      =	-1;
const int FRONT     =	 1;
const int SPANNING  =	-2;

const int TOP				=	0;  // fustrum index
const int BOTTOM		=	1;
const int LEFT			=	2;
const int RIGHT			=	3;

const int OBJECT		=	1;	// object id
const int SPHERE		=	2;
const int CYLINDER	=	3;
const int CONE			=	4;

const int MAX_VERTEXES =	16;


BITMAP *offscreen;
int XRES, YRES;
double ASPECT, h_X, h_Y, V_DX, V_DY, FOV;

#include "Math3D.h"

#include "Cam.h"
#include "Poly.h"

#include "BSP_Utils.h"
#include "BSP.h"

#include "OBJ_Utils.h"
#include "OBJ_IO.h"
#include "OBJ.h"

#include "Share3D.h"
#include "SubAffine.h"
#include "Draw3D.h"

#endif
