#ifndef _MATH_3D_H
#define _MATH_3D_H

#include <cmath>

const double PI_180 = PI/180;
typedef long fixed28_4;
typedef long fixed16_16;

inline fixed28_4 fto28_4(float val) {return val*16;}
inline fixed16_16 fto16_16(float val) {return val*65536;}
inline float fixed28_4tof(fixed28_4 val) {return val/16.0;}
inline float fixed16_16tof(fixed16_16 val) {return val/65536.0;}

inline fixed28_4 fixed28_4Mul(fixed28_4 lhs, fixed28_4 rhs) {return (lhs*rhs)/16;}

inline void FloorDivMod(long num, long denom, long &Floor,	long &Mod) {
	if(num >= 0) {
		Floor = num / denom;
		Mod = num % denom;
	}
	else {
		Floor = -((-num) / denom);
		Mod = (-num) % denom;
		if(Mod) {
			Floor--; Mod = denom - Mod;
		}
	}
}

inline long ceil28_4(fixed28_4 val) {
	long rVal;
	long num = val - 1 + 16;
	if(num >= 0) {
		rVal = num/16;
	}
	else {
		rVal = -((-num)/16);
		rVal -= ((-num) % 16) ? 1 : 0;
	}
	return rVal;
}

#include "Vect3D.h"
#include "Matrix.h"


#endif