#include <dos.h>
#include <conio.h>

#include "Base_3D.h"

volatile int FPS            =0;
volatile int CURR_FPS       =0;
volatile int FPS_Count			=0;
int  _FPS_   = 60;
int _MSEC_=(int) (1193181 / (_FPS_));
void FPS_counter() {
	FPS=1;
}
END_OF_FUNCTION(FPS_counter);

void increm_FPS_count() {
  FPS_Count++;
}
END_OF_FUNCTION(increm_FPS_count);


BITMAP *TestTexture[4];
int num_NON_backface_polys=0, num_polys=0, num_tris=0;
int just_traverse_BSP=0, no_offscreen_draw=0;
int tex_LUT=0;
long total_frames=0;
double xpos,ypos,zpos,xrot,yrot,zrot,scale;

Vect3D sc,tr,ro, motion, movement;
double current_speed=0;
void process_input();

int main(int argc, char **argv) {
	PALETTE pal;
	BSP_Tree Tree;
	Poly_List polygons;

	char buf[32],ans;
	volatile int T_FPS=0;
	clrscr();
	cout << "\t\t\t-------------------------\n";
	cout << "\t\t\t|  TEST  VERSION 0.7.0  |\n";
	cout << "\t\t\t| ********************* |\n";
	cout << "\t\t\t| Fix Clip (u,v)   .1   |\n";
	cout << "\t\t\t| PerPoly Textures .0.5 |\n";
	cout << "\t\t\t| World Collision  .1.5 |\n";
	cout << "\t\t\t-------------------------\n\n";

	if(argc<2) {
		cout << "Specify vertex file." << endl;
		return 1;
	}

	strcpy(buf, argv[1]);
	if(buf[strlen(buf)-4] != '.')
		strcat(buf, ".t3d");
	
	if(stricmp(buf+strlen(buf)-3, "b3d")!=0)
		read_OBJ(buf, polygons);
	else
		read_binary_OBJ(buf, polygons);
	cout << "  Inserted " << polygons.size() << " (Poly's) into list.\n";

	Tree.build(polygons);
	polygons.clear();
	cout << "  Tree built with " << Tree.size() << " polygons in " << Tree.leafs() << " leafs.\n\n";

	xpos=ypos=zpos=xrot=yrot=zrot=0;
	scale=1;
	ypos=256;
	zpos=-5000;
	player.pos.set(xpos,ypos,zpos);
	ro.set(xrot,yrot,zrot);

	XRES=800;
	YRES=600;
	h_X=XRES/2;
	h_Y=YRES/2;
	FOV=90;
	init_space();

	cout << "About to begin main loop...\n";
	cout << "Proceed with test  [y/n]: ";
	cin >> ans;
	if(ans=='n' || ans=='N')
		return 0;

	allegro_init();
	install_keyboard();
	install_timer();
	set_color_conversion(COLORCONV_TOTAL);
	set_gfx_mode(GFX_AUTODETECT, XRES, YRES, 0, 0);

	TestTexture[0]=load_bmp("TestTexture.bmp", pal);
	TestTexture[1]=load_bmp("TestTexture1.bmp", pal);
	TestTexture[2]=load_bmp("TestTexture2.bmp", pal);
	TestTexture[3]=load_bmp("TestTexture3.bmp", pal);
	set_palette(pal);

	LOCK_VARIABLE(FPS);
	LOCK_VARIABLE(CURR_FPS);
	LOCK_VARIABLE(T_FPS);
	LOCK_FUNCTION(FPS_counter);
	install_int_ex(FPS_counter,MSEC_TO_TIMER(1000));

	LOCK_VARIABLE(FPS_Count);
  LOCK_FUNCTION(increm_FPS_count);
  install_int_ex(increm_FPS_count,_MSEC_);

	offscreen=create_bitmap(XRES,YRES);

	clear(screen);
	clear(offscreen);

	player.orientation.transform(sc, tr, ro);
	clear_keybuf();

	while (!key[KEY_ESC]) {
		while(FPS_Count>0) {
			num_NON_backface_polys=num_polys=num_tris=0;
			clear(offscreen);
			rect(offscreen, 0,0, XRES-1, YRES-1, 255);	

			Tree.render();

			if(FPS==1) {
				FPS=0;
				T_FPS=CURR_FPS;
				CURR_FPS=0;
			}
			itoa(T_FPS,buf,10);
			textout(offscreen, font,buf,10,10,255);	

			total_frames++;
			itoa(total_frames,buf,10);
			textout(offscreen, font,buf,100,10,255);

			itoa(num_NON_backface_polys, buf, 10);
			textout(offscreen, font, buf, 600, 10, 255);
			itoa(num_polys, buf, 10);
			textout(offscreen, font, buf, 600, 20, 255);
			itoa(num_tris, buf, 10);
			textout(offscreen, font, buf, 600, 30, 255);


			itoa((int)current_speed, buf, 10);
			textout(offscreen, font, buf, 10, 420, 255);
			itoa((int)player.pos.getx(), buf, 10);
			textout(offscreen, font, buf, 10, 440, 255);
			itoa((int)player.pos.gety(), buf, 10);
			textout(offscreen, font, buf, 10, 450, 255);
			itoa((int)player.pos.getz(), buf, 10);
			textout(offscreen, font, buf, 10, 460, 255);
		
			blit(offscreen, screen, 0, 0, 0, 0, XRES, YRES);
			process_input();
			CURR_FPS++;
			FPS_Count--;
		}
	}
	clear_keybuf();
	textout(screen, font, "Test ended. Hit a key.", 320, 240, 255);
	readkey();
	return 0;
}

void process_input() {
	movement.set(player.orientation[8], player.orientation[9], player.orientation[10]);
	motion.set(movement.dot(Vect3D(1,0,0)), 0, movement.dot(Vect3D(0,0,1)));

	player.pos += motion*current_speed;

	if(key[KEY_Y]) {
		if (key_shifts & KB_SHIFT_FLAG)
			player.pos.sety(player.pos.gety()+18.0F);
		else
			player.pos.sety(player.pos.gety()-18.0F);
	}

	if(key[KEY_E]) {
			current_speed+=MOVEMENT_SPEED;
			if(current_speed > MAX_MOVEMENT_SPEED) current_speed=MAX_MOVEMENT_SPEED;
	}
	if(key[KEY_D]) {
			current_speed-=MOVEMENT_SPEED;
			if(current_speed < -MAX_MOVEMENT_SPEED) current_speed=-MAX_MOVEMENT_SPEED;
	}

	if(key[KEY_F]) {
			yrot+=0.9F;
	}
	if(key[KEY_A]) {
			yrot-=0.9F;
	}

	if(key[KEY_S]) {
		if (key_shifts & KB_SHIFT_FLAG)
			xrot+=0.9F;
		else
			xrot-=0.9F;
	}

	if(key[KEY_R]) {
		xpos=0;
		ypos=256;
		zpos=-5000;
		xrot=yrot=zrot=0;
		player.pos.set(xpos,ypos,zpos);
	}

	if(key[KEY_B])
		just_traverse_BSP^=1;
	if(key[KEY_O])
		no_offscreen_draw^=1;

	if(key[KEY_0])
		tex_LUT = 0;
	if(key[KEY_1])
		tex_LUT = 1;
	if(key[KEY_2])
		tex_LUT = 2;
	if(key[KEY_3])
		tex_LUT = 3;


	player.orientation.setIdentity();
	ro.set(xrot, yrot, zrot);
	player.orientation.rotate(ro);  // create new xform

	build_fustrum();

  if (current_speed > (MOVEMENT_SPEED  / 2.0))
    current_speed -= MOVEMENT_SPEED / 2.0;
  else if (current_speed < -(MOVEMENT_SPEED  / 2.0))
    current_speed += MOVEMENT_SPEED  / 2.0;
  else
    current_speed = 0;
}